﻿Imports C1.C1Excel
Imports System.Globalization

Public Class Form1
    Dim book As C1.C1Excel.C1XLBook
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        book = New C1.C1Excel.C1XLBook()
        book.Load("../../Sample.xls")
        MessageBox.Show("Excel file loaded")
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        SaveNewExcel(book)
        MessageBox.Show("Excel file saved")
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Public Sub SaveNewExcel(book As C1.C1Excel.C1XLBook)
        'Create a merged cell
        Dim _RowRange As XLCellRange = New C1.C1Excel.XLCellRange(0, 1, 1, 2)
        book.Sheets(0).MergedCells.Add(_RowRange)

        Dim sheet As C1.C1Excel.XLSheet = book.Sheets(0)
        'Wrap the text in a merged cell
        Dim style As New XLStyle(book)
        style.WordWrap = True
        sheet(0, 1).Style = style

        'Code to adjust the row height
        Dim rowHeight As Integer = sheet.DefaultRowHeight
        Dim colWidth As Integer = sheet.DefaultColumnWidth

        Using g As Graphics = Graphics.FromHwnd(IntPtr.Zero)
            For Each cr As XLCellRange In sheet.MergedCells
                ' get value (unformatted at this point)
                Dim value = cr.Value
                If value Is Nothing OrElse value.ToString().Length = 0 Then
                    Continue For
                End If
                ' sanity value
                Dim text = value.ToString()

                ' calculation merged cell size
                Dim width As Integer = 0, height As Integer = 0, lastHeight As Integer = sheet.DefaultRowHeight

                For i As Integer = cr.ColumnFrom To cr.ColumnTo
                    width += C1XLBook.TwipsToPixels(If(sheet.Columns(i).Width > 0, sheet.Columns(i).Width, sheet.DefaultColumnWidth))
                Next

                For i As Integer = cr.RowFrom To cr.RowTo
                    lastHeight = If(sheet.Rows(i).Height > 0, sheet.Rows(i).Height, sheet.DefaultRowHeight)
                    height += C1XLBook.TwipsToPixels(lastHeight)
                Next

                ' format value if cell has a style with format set
                Dim s = sheet.MergedCells(0).Style
                If s IsNot Nothing AndAlso s.Format.Length > 0 AndAlso TypeOf value Is IFormattable Then
                    Dim fmt As String = XLStyle.FormatXLToDotNet(s.Format)
                    text = DirectCast(value, IFormattable).ToString(fmt, CultureInfo.CurrentCulture)
                End If

                ' get font (default or style)
                Dim font = If((s IsNot Nothing AndAlso s.Font IsNot Nothing), s.Font, book.DefaultFont)

                ' measuring text
                Dim sz = Size.Ceiling(g.MeasureString(text + (If(s.WordWrap, Environment.NewLine, String.Empty)) + "XX", font, width))

                ' correct last height
                Dim delta = C1XLBook.PixelsToTwips(sz.Height - height)
                If lastHeight + delta >= 0 Then
                    sheet.Rows(cr.RowTo).Height = lastHeight + delta
                End If
            Next
        End Using


        'Save the modified Excel file
        book.Save("../../C1Sample.xls")
    End Sub
End Class
